src/main/java/gob/sv/isna/controladores/LoginMB.java
package gob.sv.isna.controladores;

import java.io.IOException;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.web.WebAttributes;

import gob.sv.isna.util.MsgUtil;

@ManagedBean(name = "login")
@RequestScoped
public class LoginMB implements PhaseListener {

	private static final long serialVersionUID = 1L;

	public String doLogin() throws ServletException, IOException {
		ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();

		RequestDispatcher dispatcher = ((ServletRequest) context.getRequest())
				.getRequestDispatcher("/j_spring_security_check");

		dispatcher.forward((ServletRequest) context.getRequest(), (ServletResponse) context.getResponse());

		FacesContext.getCurrentInstance().responseComplete();

		return null;
	}

	public String logout() throws ServletException, IOException {
		ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();

		RequestDispatcher dispatcher = ((ServletRequest) context.getRequest()).getRequestDispatcher("/logout");

		dispatcher.forward((ServletRequest) context.getRequest(), (ServletResponse) context.getResponse());

		FacesContext.getCurrentInstance().responseComplete();

		return null;
	}

	@Override
	public void afterPhase(PhaseEvent event) {
	}

	@Override
	public void beforePhase(PhaseEvent event) {

		Exception e = (Exception) FacesContext.getCurrentInstance().getExternalContext().getSessionMap()
				.get(WebAttributes.AUTHENTICATION_EXCEPTION);

		if (e instanceof BadCredentialsException) {
			FacesContext.getCurrentInstance().getExternalContext().getSessionMap()
					.put(WebAttributes.AUTHENTICATION_EXCEPTION, null);
			MsgUtil.msgError("Error!", "Usuario y/o Contraseņa invalidos...");
		}
	}

	@Override
	public PhaseId getPhaseId() {
		return PhaseId.RENDER_RESPONSE;
	}
}

src/main/java/gob/sv/isna/controladores/UsuarioMB.java
package gob.sv.isna.controladores;

import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;

import gob.sv.isna.modelo.Rol;
import gob.sv.isna.modelo.Usuario;
import gob.sv.isna.servicio.DemopfServicio;
import gob.sv.isna.util.MsgUtil;
import javax.inject.Named;
import org.springframework.beans.factory.annotation.Autowired;

@Named("usuarioMB")
@ViewScoped
public class UsuarioMB implements Serializable {

	private static final long serialVersionUID = 1L;

	@Autowired
	DemopfServicio demopfServicio;

	private Usuario usuario;
	private Usuario slcUsuario;
	private boolean editar = false;
	private List<Usuario> filtroUsuarios;

	public UsuarioMB() {

	}

	@PostConstruct
	public void inicio() {

		usuario = new Usuario();

	}

	public void guardar() {

		if (!editar) {
			try {
				demopfServicio.guardarUsuario(usuario);
				this.cancelar();
				MsgUtil.msgInfo("Exito!", "Usuario guardado correctamente.");
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else {
			try {
				demopfServicio.actualizarUsuario(usuario);
				this.cancelar();
				MsgUtil.msgWarning("Advertencia!", "Usuario actualizado.");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}

	public void actualizar() {
		usuario = slcUsuario;
		editar = true;
	}

	public void eliminar() {

		try {
			demopfServicio.eliminarUsuario(slcUsuario);
			MsgUtil.msgError("Error!", "Usuario eliminado correctamente.");
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public void cancelar() {
		usuario = new Usuario();
		editar = false;
	}

	public List<Usuario> getUsuarios() {
		return demopfServicio.obtenerUsuarios();
	}

	public List<Rol> getRoles() {
		return demopfServicio.obtenerRoles();
	}

	public void setDemopfServicio(DemopfServicio demopfServicio) {
		this.demopfServicio = demopfServicio;
	}

	public Usuario getUsuario() {
		return usuario;
	}

	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}

	public Usuario getSlcUsuario() {
		return slcUsuario;
	}

	public void setSlcUsuario(Usuario slcUsuario) {
		this.slcUsuario = slcUsuario;
	}

	public List<Usuario> getFiltroUsuarios() {
		return filtroUsuarios;
	}

	public void setFiltroUsuarios(List<Usuario> filtroUsuarios) {
		this.filtroUsuarios = filtroUsuarios;
	}

}

src/main/webapp/accesoDenegado.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html" xmlns:p="http://primefaces.org/ui" xmlns:f="http://java.sun.com/jsf/core">

<h:head>
</h:head>

<h:body>

	<h:outputLabel value="Acceso Denegado!" style="font-weight:bold; font-size:30px;" />

</h:body>

</html>

src/main/webapp/index.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html" xmlns:p="http://primefaces.org/ui" xmlns:f="http://java.sun.com/jsf/core">

<h:head>
	<title>Acceso</title>
</h:head>

<h:body>

	<f:phaseListener type="gob.sv.isna.controladores.LoginMB" />

	<h:form id="loginForm" prependId="false">

		<p:panel>


			<f:facet name="header">Aceeso</f:facet>

			<p:panelGrid columns="3">

				<p:outputLabel for="usuario" value="Usuario:" />
				<p:inputText id="usuario" required="true" requiredMessage="Debe ingresar un Usuario" />
				<p:message for="usuario" />

				<p:outputLabel for="contrasenia" value="Contraseña:" />
				<p:password id="contrasenia" required="true" requiredMessage="Debe ingresar una Contraseña" />
				<p:message for="contrasenia" />

			</p:panelGrid>

			<f:facet name="footer">

				<p:commandButton value="Ingresar" action="#{login.doLogin}" ajax="false" />
				<p:commandButton value="Cancelar" process="@this" type="reset" />

				<p:messages id="mensajes" autoUpdate="true" showSummary="true" showDetail="true" closable="true" />

			</f:facet>

		</p:panel>

		<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />

	</h:form>


</h:body>

</html>

src/main/webapp/vistas/administrador/adminUsuarios.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html" xmlns:p="http://primefaces.org/ui" xmlns:f="http://java.sun.com/jsf/core">

<h:head>
	<title>Usuarios</title>
</h:head>

<h:body>

	<p:growl id="growl" showDetail="true" showSummary="true" autoUpdate="true" life="6000" escape="false" />

	<h:form id="formUsuarios">

		<p:panel header="Administración de Usuarios">

			<br />

			<p:panelGrid columns="3" id="panelDU">

				<f:facet name="header">Datos del Usuario</f:facet>

				<p:outputLabel value="Nombre" for="nombre" />
				<p:inputText id="nombre" value="#{usuarioMB.usuario.nombre}" required="true"
					requiredMessage="Debe ingresar un Nombre" />
				<p:message for="nombre" />

				<p:outputLabel value="Apellido Paterno" for="apePat" />
				<p:inputText id="apePat" value="#{usuarioMB.usuario.apellidoPaterno}" required="true"
					requiredMessage="Debe ingresar un Apellido Paterno" />
				<p:message for="apePat" />

				<p:outputLabel value="Apellido Materno" for="apeMat" />
				<p:inputText id="apeMat" value="#{usuarioMB.usuario.apellidoMaterno}" />
				<p:message for="apeMat" />

				<p:outputLabel value="Edad" for="edad" />
				<p:inputText id="edad" value="#{usuarioMB.usuario.edad}" />
				<p:message for="edad" />

				<p:outputLabel value="Dirección" for="direccion" />
				<p:inputText id="direccion" value="#{usuarioMB.usuario.direccion}" />
				<p:message for="direccion" />

				<p:outputLabel value="Correo" for="correo" />
				<p:inputText id="correo" value="#{usuarioMB.usuario.correo}" />
				<p:message for="correo" />

			</p:panelGrid>

			<br />

			<p:panelGrid columns="3" id="panelDCU">

				<f:facet name="header">Datos de la Cuenta del Usuario</f:facet>

				<p:outputLabel value="Usuario" for="usuario" />
				<p:inputText id="usuario" value="#{usuarioMB.usuario.usuario}" />
				<p:message for="usuario" />

				<p:outputLabel value="Contraseña" for="pass1" />
				<p:password id="pass1" value="#{usuarioMB.usuario.contrasenia}" match="pass2" feedback="true" redisplay="true"
					strongLabel="Contraseña Fuerte" goodLabel="Contraseña Buena" weakLabel="Contraseña Debil"
					label="Ingresa una contraseña" />
				<p:message for="pass1" />

				<p:outputLabel value="Repetir Contraseña" for="pass2" />
				<p:password id="pass2" value="#{usuarioMB.usuario.contrasenia}" feedback="true" redisplay="true"
					strongLabel="Contraseña Fuerte" goodLabel="Contraseña Buena" weakLabel="Contraseña Debil" />
				<p:message for="pass2" />

				<p:outputLabel value="Rol" for="rol" />
				<p:selectOneMenu id="rol" value="#{usuarioMB.usuario.rol}" converter="#{rolConverter}">
					<f:selectItem itemLabel="Elegir.." itemValue="#{null}" noSelectionOption="true" />
					<f:selectItems value="#{usuarioMB.roles}" var="r" itemLabel="#{r.descripcion}" itemValue="#{r}" />
				</p:selectOneMenu>
				<p:message for="rol" />

			</p:panelGrid>

			<p:commandButton value="Guardar" actionListener="#{usuarioMB.guardar()}" update="@form, tbl">
				<p:confirm header="Confirmación" message="Desea guardar el registro?" icon="ui-icon-alert" />
			</p:commandButton>
			<p:commandButton value="Cancelar" actionListener="#{usuarioMB.cancelar()}" update="@form" process="@this" />

			<br />
			<br />

			<p:contextMenu for="tbl">
				<p:menuitem value="Editar" update="panelDU panelDCU" icon="ui-icon-search"
					actionListener="#{usuarioMB.actualizar()}" process="tbl @this" />
				<p:menuitem value="Eliminar" update="tbl" icon="ui-icon-close" actionListener="#{usuarioMB.eliminar()}"
					process="tbl @this" />
			</p:contextMenu>

			<p:dataTable id="tbl" value="#{usuarioMB.usuarios}" var="u" emptyMessage="Sin registros"
				selection="#{usuarioMB.slcUsuario}" selectionMode="single" rowKey="#{u.id}" rows="10" paginator="true"
				paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
				rowsPerPageTemplate="5,10,15" filteredValue="#{usuarioMB.filtroUsuarios}" widgetVar="tbl">

				<f:facet name="header">Usuarios registrados</f:facet>

				<p:column headerText="ID" style="text-align:center;" filterBy="#{u.id}" filterMatchMode="exact">
					<h:outputText value="#{u.id}" />
				</p:column>

				<p:column headerText="Nombre" style="text-align:center;" filterBy="#{u.nombre}" filterMatchMode="contains">
					<h:outputText value="#{u.nombre} #{u.apellidoPaterno} #{u.apellidoMaterno}" />
				</p:column>

				<p:column headerText="Edad" style="text-align:center;" filterBy="#{u.edad}" filterMatchMode="exact">
					<h:outputText value="#{u.edad}" />
				</p:column>

				<p:column headerText="Correo" style="text-align:center;" filterBy="#{u.correo}" filterMatchMode="contains">
					<h:outputText value="#{u.correo}" />
				</p:column>

				<p:column headerText="Rol" style="text-align:center;" filterBy="#{u.rol}" filterMatchMode="exact">
					<f:facet name="filter">
						<p:selectOneMenu onchange="PF('tbl').filter()">
							<f:selectItem itemLabel="Elegir" itemValue="#{null}" noSelectionOption="true" />
							<f:selectItems value="#{usuarioMB.roles}" var="rl" itemLabel="#{rl.descripcion}" />
						</p:selectOneMenu>
					</f:facet>
					<h:outputText value="#{u.rol.descripcion}" />
				</p:column>

			</p:dataTable>

		</p:panel>

		<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />

	</h:form>

	<h:form>
		<p:commandButton action="#{login.logout}" value="Salir" ajax="false" process="@this" />
		<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />
	</h:form>

	<p:confirmDialog global="true" showEffect="fade" hideEffect="fade">
		<p:commandButton value="Si" type="button" styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
		<p:commandButton value="No" type="button" styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
	</p:confirmDialog>

</h:body>

</html>

src/main/webapp/vistas/usuario/usuarios.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html" xmlns:p="http://primefaces.org/ui" xmlns:f="http://java.sun.com/jsf/core">

<h:head>
	<title>demopf - Usuarios</title>
</h:head>

<h:body>

	<p:growl id="growl" showDetail="true" showSummary="true" autoUpdate="true" life="6000" escape="false" />

	<h:form id="formUsuarios">

		<p:panel header="Usuarios">

			<br />

			<p:dataTable id="tbl" value="#{usuarioMB.usuarios}" var="u" emptyMessage="Sin registros" rows="10" paginator="true"
				paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
				rowsPerPageTemplate="5,10,15" filteredValue="#{usuarioMB.filtroUsuarios}" widgetVar="tbl">

				<f:facet name="header">Usuarios registrados</f:facet>

				<p:column headerText="ID" style="text-align:center;" filterBy="#{u.id}" filterMatchMode="exact">
					<h:outputText value="#{u.id}" />
				</p:column>

				<p:column headerText="Nombre" style="text-align:center;" filterBy="#{u.nombre}" filterMatchMode="contains">
					<h:outputText value="#{u.nombre} #{u.apellidoPaterno} #{u.apellidoMaterno}" />
				</p:column>

				<p:column headerText="Edad" style="text-align:center;" filterBy="#{u.edad}" filterMatchMode="exact">
					<h:outputText value="#{u.edad}" />
				</p:column>

				<p:column headerText="Correo" style="text-align:center;" filterBy="#{u.correo}" filterMatchMode="contains">
					<h:outputText value="#{u.correo}" />
				</p:column>

				<p:column headerText="Rol" style="text-align:center;" filterBy="#{u.rol}" filterMatchMode="exact">
					<f:facet name="filter">
						<p:selectOneMenu onchange="PF('tbl').filter()">
							<f:selectItem itemLabel="Elegir" itemValue="#{null}" noSelectionOption="true" />
							<f:selectItems value="#{usuarioMB.roles}" var="rl" itemLabel="#{rl.descripcion}" />
						</p:selectOneMenu>
					</f:facet>
					<h:outputText value="#{u.rol.descripcion}" />
				</p:column>

			</p:dataTable>

		</p:panel>

		<p:commandButton action="#{login.logout}" value="Salir" ajax="false" process="@this" />

		<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />

	</h:form>

	<p:confirmDialog global="true" showEffect="fade" hideEffect="fade">
		<p:commandButton value="Si" type="button" styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
		<p:commandButton value="No" type="button" styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
	</p:confirmDialog>

</h:body>

</html>